part of viltage;

class Entity {
	int layer;
	int x, y;
	int width, height;
	int activeState = 0;
	int activeAnimation = -1;
	
  List<VilTAGEAnimation> animations = new List<VilTAGEAnimation>();
	List<State> states = new List<State>();
	  
  Entity.FromScreen(this.x, this.y, this.layer, VilTAGEScreen s) {
  	s.entities[layer].add(this);
  	states.add(new State());
  }
    
  Entity(this.x, this.y, this.layer, VilTAGE v) {
  	v.getScreen().entities[layer].add(this);
  	states.add(new State());
  }
  
	render(List<List<CharNode>> charArray) {
		states[activeState].render(x, y, charArray);
	}
  
	update(double delta) {
		if(activeAnimation != -1 && activeAnimation < animations.length) {
		  animations[activeAnimation].update(delta);
	    activeState = animations[activeAnimation].sequence[animations[activeAnimation].current];
		} else activeState = 0;
	}

	removeFromScreen(VilTAGEScreen s) {
		s.entities[layer].remove(this);
	}
	
	remove(VilTAGE v) {
		removeFromScreen(v.getScreen());	
	}
	  
	static clearScreen(VilTAGEScreen s) {
		for(int i = 0; i < s.entities.length; i++) {
			s.entities[i] = new List<Entity>();
		}
		Entity e = new Entity.FromScreen(0, 0, 0, s);
		for(int i = 0; i < s.viltage.width; i++) {
			for(int j = 0; j < s.viltage.height; j++) {
				e.states[0].createCharNode(i, j, s.viltage.backgroundChar);
			}
		}
	}
  
	static clear(VilTAGE v) {
	   clearScreen(v.getScreen());
	}
}