part of viltage;

class Input {
  static HashMap<int, int> _keys = new HashMap<int, int>();
  static HashMap<int, int> _lastKeys = new HashMap<int, int>();
  
  static init() {
    window.onKeyDown.listen((KeyboardEvent e) {
      if (!_keys.containsKey(e.keyCode))
        _keys[e.keyCode] = e.timeStamp;
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys.remove(e.keyCode);
    });
  }

  static bool isHeld(int keyCode) => _keys.containsKey(keyCode);
  
  static bool isPressed(int keyCode) {
    return (isHeld(keyCode) && !_lastKeys.containsKey(keyCode));
  }
  
  static update() {
    _keys.forEach((k, v) {
      _lastKeys[k] = _keys[v]; 
    });
  }
}